$(document).ready(function() {
  var request;
  var $current;
  var cache = {};
  var $frame = $('#product_viewer_frame_%id%');
  var $thumbs = $('.productviewer_thumb');

  function crossfade($img) {
    if ($current) {
      $current.stop().fadeOut(%id=fade_speed%);
    }

    $img.css({
      marginLeft: -$img.width() / 2,
      marginTop: -$img.height() / 2
    });

    $img.stop().fadeTo(%id=fade_speed%, 1);
    $current = $img;

  }

  $(document).on('click', '.productviewer_thumb', function(e){
    var $img,
        src = this.href;
        request = src;

    e.preventDefault();
    $thumbs.removeClass('active');
    $(this).addClass('active');

    if (cache.hasOwnProperty(src)) {
      if (cache[src].isLoading === false) {
        crossfade(cache[src].$img);
      }
    } else {
      $img = $('<img/>');
      cache[src] = {
        $img: $img,
        isLoading: true
      };

      $img.on('load', function(){
        $img.hide();
        $frame.removeClass('is-loading').append($img);
        cache[src].isLoading = false;
        if (request === src) {
          crossfade($img);
        }
      });

      $frame.addClass('is-loading');
      $img.attr({
        'src': src,
        'alt': this.title || ''
      });

    }

  });

  $('#product_viewer_section_%id% .productviewer_thumb:first').addClass('active');
  $('.productviewer_thumb').eq(0).click();

});